/*
 * Anfängliche Datei main.c, erzeugt durch Glade. Bearbeiten Sie
 * Sie, wie Sie wollen. Glade wird diese Datei nicht überschreiben.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdbool.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "serialport.h"
#include "interface.h"
#include "support.h"

char *BAUDRATE[18] = {"50","75","110","134","150",
                     "200","300","600","1200","1800",
			         "2400","4800","9600","19200","38400",
			         "57600","115200","230400"};

char *DEVS[4] = {"/dev/ttyS0","/dev/ttyS1","/dev/ttyS2","/dev/ttyS3"};


bool setimage(GtkWidget *widget, const char *filename);
void fill_combobox(GtkWidget *widget, int n, char **text);
					 
int main (int argc, char *argv[])
{
  GtkWidget *window1;	
  struct serial_cfg sr_cfg;
	  
  /*Immer wenn seriele Schnittstelle
    geschlossen ist fd auf -1 setzen*/
  sr_cfg.fd = -1;
  
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory ("./");/*PACKAGE_DATA_DIR*/
  add_pixmap_directory ("./");/*PACKAGE_SOURCE_DIR*/
  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_window1 ();
  gtk_object_set_data(GTK_OBJECT(window1),"sr_cfg",&sr_cfg);	
  
  fill_combobox(gtk_object_get_data(GTK_OBJECT(window1),"bautrate_combo"), 18, BAUDRATE);
  fill_combobox(gtk_object_get_data(GTK_OBJECT(window1),"schnittstelle_combo"), 4, DEVS); 
  gtk_widget_show (window1);
 
  gtk_main ();
  return 0;
}

void fill_combobox(GtkWidget *widget, int n, char *text[])
{
	int i;
    GList *items = NULL;
	
	for(i=0; i<n; i++)
		items = g_list_append (items, text[i]);
	gtk_combo_set_popdown_strings(GTK_COMBO (widget), items);	
}
	
	

bool setimage(GtkWidget *widget, const char *filename)
{
	bool rc;
	GdkColormap *colormap;
	GdkPixmap *gdkpixmap;
	GdkBitmap *mask;

	colormap = gtk_widget_get_colormap (widget);
	gdkpixmap = gdk_pixmap_colormap_create_from_xpm (NULL, colormap, &mask,
                                                   NULL, filename);
	if (gdkpixmap == NULL)
  	{
		g_warning ("Error loading pixmap file: %s", filename);
		rc = false;
	}
	else
	{
		gtk_pixmap_set(GTK_PIXMAP(widget),gdkpixmap,mask);
		gdk_pixmap_unref (gdkpixmap);
		gdk_bitmap_unref (mask);
		rc = true;
	}
	return rc;	
}


/*Diese Funktion wird aufgeruffen Falls Daten zum Lesen vorhanden sind*/
gboolean incomming_data(GIOChannel *source, GIOCondition condition, gpointer data)
{
	int size[3];
	char buffer[32];
	GtkText *empfangen = gtk_object_get_data(data,"empfangen");	
	
	g_io_channel_read(source,buffer,32,&size[0]);
	buffer[31]='\0';/*fuer alle Faelle*/
	size[1] = gtk_text_get_length(empfangen);
	gtk_editable_insert_text(GTK_EDITABLE(empfangen),buffer,size[0], &size[1]);
	g_print("incomming_data\n");
    g_print("bytes : %d\n",size[0]);
	g_print("buffer: %s\n",buffer);	
	return TRUE;	
}
/*Diese Funktion wird 1mal/s Aufgeruffen solange die Schnittstelle geoeffent bleibt*/
gint setstatus(gpointer user_data)
{
	g_print("setstatus\n");
	static bool dcd,dsr,cts,ri;
	struct serial_cfg *sr_cfg = gtk_object_get_data(user_data,"sr_cfg"); 
	
	if(dcd != get_dcd(sr_cfg))
	{
	    g_print("dcd != get_dcd(sr_cfg)\n");
		dcd = get_dcd(sr_cfg);
		if(dcd)
			setimage(gtk_object_get_data(user_data,"dcd_stat"), "./terminal_on.xpm");
		else
			setimage(gtk_object_get_data(user_data,"dcd_stat"), "./terminal_off.xpm");			
	}	
	/**********/
	if(dsr != get_dsr(sr_cfg))
	{
		g_print("dsr != get_dsr(sr_cfg)\n");
		dsr = get_dcd(sr_cfg);
		if(dsr)
			setimage(gtk_object_get_data(user_data,"dsr_stat"), "./terminal_on.xpm");
		else
			setimage(gtk_object_get_data(user_data,"dsr_stat"), "./terminal_off.xpm");			
	}	
	/**********/	
   	if(cts != get_cts(sr_cfg))
	{
		g_print("cts != get_cts(sr_cfg)\n");
		cts = get_cts(sr_cfg);
		if(cts)
			setimage(gtk_object_get_data(user_data,"cts_stat"), "./terminal_on.xpm");
		else
			setimage(gtk_object_get_data(user_data,"cts_stat"), "./terminal_off.xpm");			
	}	
   	/**********/	
   	if(ri != get_ri(sr_cfg))
	{
		g_print("ri != get_ri(sr_cfg)\n");
		ri = get_ri(sr_cfg);
		if(ri)
			setimage(gtk_object_get_data(user_data,"ri_stat"), "./terminal_on.xpm");
		else
			setimage(gtk_object_get_data(user_data,"ri_stat"), "./terminal_off.xpm");			
	}	
	
	return TRUE;	
}
